import PreviewMessagingBase from "../PreviewMessagingBase";
import Version from "../../base/Version";
import { BroadcastListInstance } from "./v1/broadcast";
import { MessageListInstance } from "./v1/message";
export default class V1 extends Version {
    /**
     * Initialize the V1 version of PreviewMessaging
     *
     * @param domain - The Twilio (Twilio.PreviewMessaging) domain
     */
    constructor(domain: PreviewMessagingBase);
    /** broadcasts - { Twilio.PreviewMessaging.V1.BroadcastListInstance } resource */
    protected _broadcasts?: BroadcastListInstance;
    /** messages - { Twilio.PreviewMessaging.V1.MessageListInstance } resource */
    protected _messages?: MessageListInstance;
    /** Getter for broadcasts resource */
    get broadcasts(): BroadcastListInstance;
    /** Getter for messages resource */
    get messages(): MessageListInstance;
}
